package com.dashitech.migration.task.consumable;

import com.dashitech.migration.BaseTask;
import com.dashitech.migration.core.DataMigrationter;
import com.dashitech.migration.core.FieldMapper;
import com.dashitech.migration.task.uc.HospitalTask;
import com.dashitech.migration.util.JdbcUtil;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author song
 * @date 2024年10月12日
 */
@Component
public class ProductTask extends BaseTask {

    public static Log log = LogFactory.getLog(ProductTask.class);

    @Autowired
    private HospitalTask hospitalTask;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void start() {
        log.info("耗材转产品ProductTask转换开始");
        StringBuffer sql = new StringBuffer("SELECT NAME,IFNULL(spd_code,spdcode) as code,brand_model as brand,specification as model,");
        sql.append("unit,duty_id as hos_id,delete_flag FROM itsm_asset_consumable");
        List<Map<String, Object>> productList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        mapper.addOperationReplace("hos_id", hospitalTask.loadCache().getIdCache());
        mapper.addOperationAdd("main_type", getDicTreeId(jdbcTemplateHsms, "product_category_type", "1008"));
        mapper.trans2JdbcRow(productList);

        JdbcUtil jdbcUtil = new JdbcUtil(jdbcTemplateHsms);
        jdbcUtil.batchPageInsert("itsm_itsm_asset_product", mapper.getRows());

        mapper.clear();

    }

    @Override
    public FieldMapper loadCache() {
        log.info(" *** 加载product缓存 *** ");
        StringBuffer sql = new StringBuffer("select id,code from itsm_itsm_asset_product");
        List<Map<String, Object>> productList = jdbcTemplateHsms.queryForList(sql.toString());
        sql = new StringBuffer("SELECT id,IFNULL(spd_code,spdcode) as code FROM itsm_asset_consumable");
        List<Map<String, Object>> consumableList = jdbcTemplateMdv2.queryForList(sql.toString());
        FieldMapper mapper = new FieldMapper();
        mapper.addFieldMapper("code", "code");

        DataMigrationter.loadCache(productList, consumableList, mapper);
        return mapper;
    }
}
